=== test/CMakeLists.txt ===
set(ZFP_LIB_VERSION ${ZFP_VERSION_MAJOR}${ZFP_VERSION_MINOR}${ZFP_VERSION_PATCH})
if (ZFP_VERSION VERSION_GREATER_EQUAL 1.0.0)
  set(ZFP_LIB_VERSION ${ZFP_LIB_VERSION}${ZFP_VERSION_TWEAK})
endif ()
set(ZFP_HAS_CFP 0)
if (ZFP_CFP_ENABLED)
  set(ZFP_HAS_CFP 1)
endif()

# HDF5 docs say H5Dwrite_chunk was introduced in 1.10.2
set(HDF5_HAS_WRITE_CHUNK 0)
if ("${HDF5_VERSION}" VERSION_GREATER_EQUAL "1.10.2")
    set(HDF5_HAS_WRITE_CHUNK 1)
endif()

#------------------------------------------------------------------------------#
# Setup HDF5_PLUGIN_PATH
#------------------------------------------------------------------------------#
get_target_property(HDF5_PLUGIN_PATH h5z_zfp_shared RUNTIME_OUTPUT_DIRECTORY)
if (_isMultiConfig)
  set(HDF5_PLUGIN_PATH "${HDF5_PLUGIN_PATH}/${HDF_CFG_NAME}")
endif ()

#------------------------------------------------------------------------------#
# Plugin and library write & read tests (No check implemented)
#------------------------------------------------------------------------------#
add_executable(test_write_plugin test_write.c)
target_compile_definitions(test_write_plugin PRIVATE H5Z_ZFP_USE_PLUGIN)
target_compile_definitions(test_write_plugin PRIVATE ZFP_LIB_VERSION=0x${ZFP_LIB_VERSION})
target_link_libraries(test_write_plugin h5z_zfp_shared)

add_executable(test_read_plugin test_read.c)
target_compile_definitions(test_read_plugin PRIVATE H5Z_ZFP_USE_PLUGIN)
target_link_libraries(test_read_plugin h5z_zfp_shared)

add_executable(test_write_lib test_write.c)
target_compile_definitions(test_write_lib PRIVATE ZFP_LIB_VERSION=0x${ZFP_LIB_VERSION})
target_compile_definitions(test_write_lib PRIVATE HDF5_HAS_WRITE_CHUNK=${HDF5_HAS_WRITE_CHUNK})
target_compile_definitions(test_write_lib PRIVATE ZFP_HAS_CFP=${ZFP_HAS_CFP})
target_link_libraries(test_write_lib h5z_zfp_static)
if (ZFP_CFP_ENABLED)
  target_link_libraries(test_write_lib zfp::cfp)
endif ()

add_executable(test_read_lib test_read.c)
target_link_libraries(test_read_lib h5z_zfp_static)

if (FORTRAN_INTERFACE)
  add_executable(test_rw_fortran test_rw_fortran.F90)
  target_link_libraries(test_rw_fortran h5z_zfp_static)
  set_target_properties (test_rw_fortran PROPERTIES LINKER_LANGUAGE Fortran)
endif ()

#------------------------------------------------------------------------------#
# Tests
#------------------------------------------------------------------------------#

if (MSVC)
  string(REPLACE ";" "\\;" ESCAPED_PATH "$ENV{PATH}")
endif ()

# Rate
set(RATE_RATE 32 16 8 4)
if (MSVC)
  set(RATE_DIFF 3e-7 0.008 2.0 45)
else ()
  set(RATE_DIFF 1e-7 0.003 0.4 33)
endif ()
list(LENGTH RATE_RATE NRATES)
math(EXPR NRATES "${NRATES} - 1")
foreach (IRATE RANGE ${NRATES})
  list(GET RATE_RATE ${IRATE} RATE)
  list(GET RATE_DIFF ${IRATE} DIFF)

  add_test(
    NAME
      test-rate-write-${RATE}
    COMMAND
      $<TARGET_FILE:test_write_plugin> zfpmode=1 rate=${RATE} ofile=test_zfp-rate-${RATE}.h5
  )
  set_property(
    TEST
      test-rate-write-${RATE}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-rate-write-${RATE}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()

  add_test(
    NAME
      test-rate-read-${RATE}
    COMMAND
      $<TARGET_FILE:test_read_plugin> max_absdiff=${DIFF} max_reldiff=${DIFF} ifile=test_zfp-rate-${RATE}.h5
  )
  set_property(
    TEST
      test-rate-read-${RATE}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-rate-read-${RATE}
      APPEND
      PROPERTY
        ENVIRONMENT "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()
  set_tests_properties (test-rate-read-${RATE} PROPERTIES DEPENDS test-rate-write-${RATE})

  add_test(
    NAME
      test-rate-cleanup-${RATE}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-rate-${RATE}.h5
  )
  set_tests_properties (test-rate-cleanup-${RATE} PROPERTIES DEPENDS test-rate-read-${RATE})

  set_tests_properties(test-rate-write-${RATE}   PROPERTIES FIXTURES_SETUP    "rate-read-${RATE};rate-cleanup-${RATE}")
  set_tests_properties(test-rate-write-${RATE}   PROPERTIES FIXTURES_REQUIRED "rate-write-${RATE}")
  set_tests_properties(test-rate-read-${RATE}    PROPERTIES FIXTURES_REQUIRED "rate-read-${RATE}")
  set_tests_properties(test-rate-cleanup-${RATE} PROPERTIES FIXTURES_REQUIRED "rate-cleanup-${RATE}")
  set_tests_properties(test-rate-cleanup-${RATE} PROPERTIES FIXTURES_CLEANUP  "rate-write-${RATE};rate-read-${RATE}")

  add_test(
    NAME
      test-lib-rate-write-${RATE}
    COMMAND
      $<TARGET_FILE:test_write_lib> zfpmode=1 rate=${RATE} ofile=test_zfp-lib-rate-${RATE}.h5
  )

  add_test(
    NAME
      test-lib-rate-read-${RATE}
    COMMAND
      $<TARGET_FILE:test_read_lib> max_absdiff=${DIFF} max_reldiff=${DIFF} ifile=test_zfp-lib-rate-${RATE}.h5
  )
  set_tests_properties (test-lib-rate-read-${RATE} PROPERTIES DEPENDS test-lib-rate-write-${RATE})

  add_test(
    NAME
      test-lib-rate-cleanup-${RATE}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-lib-rate-${RATE}.h5
  )
  set_tests_properties (test-lib-rate-cleanup-${RATE} PROPERTIES DEPENDS test-lib-rate-read-${RATE})

  set_tests_properties(test-lib-rate-write-${RATE}   PROPERTIES FIXTURES_SETUP    "lib-rate-read-${RATE};lib-rate-cleanup-${RATE}")
  set_tests_properties(test-lib-rate-write-${RATE}   PROPERTIES FIXTURES_REQUIRED "lib-rate-write-${RATE}")
  set_tests_properties(test-lib-rate-read-${RATE}    PROPERTIES FIXTURES_REQUIRED "lib-rate-read-${RATE}")
  set_tests_properties(test-lib-rate-cleanup-${RATE} PROPERTIES FIXTURES_REQUIRED "lib-rate-cleanup-${RATE}")
  set_tests_properties(test-lib-rate-cleanup-${RATE} PROPERTIES FIXTURES_CLEANUP  "lib-rate-write-${RATE};lib-rate-read-${RATE}")

  if (NOT MSVC AND FORTRAN_INTERFACE)
    add_test(
      NAME
        test-rate-write-${RATE}-f
      COMMAND
        $<TARGET_FILE:test_rw_fortran> zfpmode 1 rate ${RATE} ofile test_zfp_fortran-rate-${RATE}.h5
    )

    add_test(
      NAME
        test-rate-info1-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}"
        -D "TEST_PROGRAM=${HDF5_DUMP_EXECUTABLE}"
        -D "TEST_FILE=test_zfp_fortran-rate-${RATE}.h5"
        -D "TEST_DSET=compressed"
        -D "TEST_RATE=${RATE}"
        -D "RATE_START=64"
        -P "${CMAKE_CURRENT_SOURCE_DIR}/h5dump-rate.cmake"
    )
    set_tests_properties (test-rate-info1-${RATE}-f PROPERTIES DEPENDS test-rate-write-${RATE}-f)

    add_test(
      NAME
        test-rate-info2-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}"
        -D "TEST_PROGRAM=${HDF5_DUMP_EXECUTABLE}"
        -D "TEST_FILE=test_zfp_fortran-rate-${RATE}.h5"
        -D "TEST_DSET=compressed-plugin"
        -D "TEST_RATE=${RATE}"
        -D "RATE_START=64"
        -P "${CMAKE_CURRENT_SOURCE_DIR}/h5dump-rate.cmake"
    )
    set_tests_properties (test-rate-info2-${RATE}-f PROPERTIES DEPENDS test-rate-info1-${RATE}-f)

    add_test(
      NAME
        test-rate-cleanup-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}" -E remove test_zfp_fortran-rate-${RATE}.h5
    )
    set_tests_properties (test-rate-cleanup-${RATE}-f PROPERTIES DEPENDS test-rate-info2-${RATE}-f)

    set_tests_properties(test-rate-write-${RATE}-f   PROPERTIES FIXTURES_SETUP    "rate-info1-${RATE}-f;rate-info1-${RATE}-f;rate-cleanup-${RATE}-f")
    set_tests_properties(test-rate-write-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-write-${RATE}-f")
    set_tests_properties(test-rate-info1-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-info1-${RATE}-f")
    set_tests_properties(test-rate-info2-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-info2-${RATE}-f")
    set_tests_properties(test-rate-cleanup-${RATE}-f PROPERTIES FIXTURES_REQUIRED "rate-cleanup-${RATE}-f")
    set_tests_properties(test-rate-cleanup-${RATE}-f PROPERTIES FIXTURES_CLEANUP  "rate-write-${RATE}-f;rate-info1-${RATE}-f;rate-info1-${RATE}-f")
  endif ()
endforeach ()

# Accuracy
set(ACC_NO 1 2 3 4)
set(ACC_ACC 0.1 0.01 0.001 0.0001)
set(ACC_DIFF 0.025 0.004 0.0006 4e-5)
list(LENGTH ACC_NO NACCS)
math(EXPR NACCS "${NACCS} - 1")
foreach (IACC RANGE ${NACCS})
  list(GET ACC_NO ${IACC} NUMBER)
  list(GET ACC_ACC ${IACC} ACC)
  list(GET ACC_DIFF ${IACC} DIFF)

  add_test(
    NAME
      test-accuracy-write-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_write_plugin> zfpmode=3 acc=${ACC} ofile=test_zfp-acc-${NUMBER}.h5
  )
  set_property(
    TEST
      test-accuracy-write-${NUMBER}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-accuracy-write-${NUMBER}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()

  add_test(
    NAME
      test-accuracy-read-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_read_plugin> ret=1 max_absdiff=${DIFF} ifile=test_zfp-acc-${NUMBER}.h5
  )
  set_property(
    TEST
      test-accuracy-read-${NUMBER}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-accuracy-read-${NUMBER}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()
  set_tests_properties (test-accuracy-read-${NUMBER} PROPERTIES DEPENDS test-accuracy-write-${NUMBER})

  add_test(
    NAME
      test-accuracy-cleanup-${NUMBER}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-acc-${NUMBER}.h5
  )
  set_tests_properties (test-accuracy-cleanup-${NUMBER} PROPERTIES DEPENDS test-accuracy-read-${NUMBER})

  set_tests_properties(test-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_SETUP    "accuracy-read-${NUMBER};accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_REQUIRED "accuracy-write-${NUMBER}")
  set_tests_properties(test-accuracy-read-${NUMBER}    PROPERTIES FIXTURES_REQUIRED "accuracy-read-${NUMBER}")
  set_tests_properties(test-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_REQUIRED "accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_CLEANUP  "accuracy-write-${NUMBER};accuracy-read-${NUMBER}")

  add_test(
    NAME
      test-lib-accuracy-write-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_write_lib> zfpmode=3 acc=${ACC} ofile=test_zfp-lib-acc-${NUMBER}.h5
  )

  add_test(
    NAME
      test-lib-accuracy-read-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_read_lib> ret=1 max_absdiff=${DIFF} ifile=test_zfp-lib-acc-${NUMBER}.h5
  )
  set_tests_properties (test-lib-accuracy-read-${NUMBER} PROPERTIES DEPENDS test-lib-accuracy-write-${NUMBER})

  add_test(
    NAME
      test-lib-accuracy-cleanup-${NUMBER}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-lib-acc-${NUMBER}.h5
  )
  set_tests_properties (test-lib-accuracy-cleanup-${NUMBER} PROPERTIES DEPENDS test-lib-accuracy-read-${NUMBER})

  set_tests_properties(test-lib-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_SETUP    "lib-accuracy-read-${NUMBER};lib-accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-lib-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_REQUIRED "lib-accuracy-write-${NUMBER}")
  set_tests_properties(test-lib-accuracy-read-${NUMBER}    PROPERTIES FIXTURES_REQUIRED "lib-accuracy-read-${NUMBER}")
  set_tests_properties(test-lib-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_REQUIRED "lib-accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-lib-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_CLEANUP  "lib-accuracy-write-${NUMBER};lib-accuracy-read-${NUMBER}")

  if (FORTRAN_INTERFACE)
    add_test(
      NAME
        test-accuracy-write-${NUMBER}-f
      COMMAND
        $<TARGET_FILE:test_rw_fortran> zfpmode 3 acc ${ACC} ofile test_zfp_fortran-acc-${NUMBER}.h5 write
    )

    add_test(
      NAME
        test-accuracy-diff1-${NUMBER}-f
      COMMAND
