=== debian/changelog ===
h5z-zfp (1.1.1-2) unstable; urgency=medium

  * d/t/control: No need to rebuild, rely on the testbed
    setup to check the rebuild.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 19 Jan 2024 13:27:49 +0100

h5z-zfp (1.1.1-1) unstable; urgency=medium

  * Team upload.

  [ Helmut Grohne ]
  * New upstream version 1.1.0+git20230428

  [ Picca Frédéric-Emmanuel ]
  * d/watch: Fixed by using the github snipset from uscan documentation
  * New upstream version 1.1.1
  * d/t/control: run the upstream testsuite.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 18 Jan 2024 11:48:33 +0100
